package com.unq.ardupong.joystickbt;

import java.io.IOException;
import java.io.OutputStream;
import java.util.Set;
import java.util.UUID;

import android.support.v7.app.ActionBarActivity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.widget.TextView;

public class MainActivity extends ActionBarActivity {
	
	private TextView _txtMessages;
	private RadioButton _btnJoyStickIzquierdo;
	private RadioButton _btnJoyStickDerecho;
	private SeekBar _seekBar;
	private Button	_btnStart;
	private OutputStream outputStream;
	private static final UUID MY_UUID = UUID.fromString("00001101-0000-1000-8000-00805f9b34fb");

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		_txtMessages = (TextView) findViewById(R.id.txtMessages);
		_btnJoyStickIzquierdo = (RadioButton)findViewById(R.id.radio0 );
		_btnJoyStickDerecho = (RadioButton)findViewById(R.id.radio1 );
						
		try {
			BTinit();
		} catch (IOException e) {	
			_txtMessages.setText("Revento inicio Bluetooth :(");
			e.printStackTrace();
		}
		
		_seekBar = (SeekBar) findViewById(R.id.seekBar);
		_seekBar.setOnSeekBarChangeListener(
				new OnSeekBarChangeListener() {
				        @Override
				      public void onProgressChanged(SeekBar seekBar,
				    		  						int progressValue, 
				    		  						boolean fromUser) {
				        	
				        _txtMessages.setText( "Valor " +	String.valueOf((progressValue*100)/63) + "%" );
				        				        
				        try 
				        {				        	
				        	char c = (char) (progressValue & 0x3F);
				        	c |= (_btnJoyStickIzquierdo.isChecked()?((char)0x00):((char)0x40));
				        	String command = "";
				        	command += c;
					        
							BTwrite( command );
						} 
				        catch (IOException e) 
				        {
							e.printStackTrace();
						}
				      }
				
				      @Override
				      public void onStartTrackingTouch(SeekBar seekBar) {
				      }
				
				      @Override
				      public void onStopTrackingTouch(SeekBar seekBar) {
				      }
				});
		
		
		_btnStart = (Button)findViewById(R.id.btnStart );
		_btnStart.setOnClickListener(
					new OnClickListener() {
						
						@Override
						public void onClick(View v) {
							try 
					        {				        	
					        	String command = "";
					        	command +=  (char)0x3F;
						        
								BTwrite( command );
							} 
					        catch (IOException e) 
					        {
								e.printStackTrace();
							}							
						}
					}
				);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
	
	
	private void BTinit() throws IOException {
	    
		BluetoothAdapter blueAdapter = BluetoothAdapter.getDefaultAdapter();
	    
	    if (blueAdapter != null) 
	    {
	        if (blueAdapter.isEnabled()) 
	        {
	            Set<BluetoothDevice> bondedDevices = blueAdapter.getBondedDevices();

	            if(bondedDevices.size() > 0)
	            {
	            	BluetoothDevice device = null;
	            	for( BluetoothDevice dev : bondedDevices )
	            		device = dev;
	            	
	            	if( device != null )
	            	{
	            		BluetoothSocket socket = device.createRfcommSocketToServiceRecord(MY_UUID);
	            		socket.connect();
	            		outputStream = socket.getOutputStream();
	            		
	            		_txtMessages.setText("Bluetooth inicializado...");
	            	}
	            	else
	            		_txtMessages.setText("No hay dispositivos vinculados...");	                
	            }
	            else
	            	_txtMessages.setText("No hay dispositivos vinculados...");
	        }
	        else 
	        	_txtMessages.setText("Bluetooth desactivado...");
	        
	    }
	    else
	    	_txtMessages.setText("No hay interface Bluetooth?");
	}

	public void BTwrite(String s) throws IOException 
	{
		if( outputStream != null )
			outputStream.write(s.getBytes());
	}

}
